## cataclysm-dda 0.E

=== CMakeLists.txt ===
# Main project build script
cmake_minimum_required(VERSION 3.1.4)

PROJECT(CataclysmDDA)

SET(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${CMAKE_SOURCE_DIR}/CMakeModules
)

SET(CMAKE_TLS_VERIFY ON)

# Build options
option(TILES        "Build graphical tileset version."   "OFF")
option(CURSES       "Build curses version."   "ON")
option(SOUND        "Support for in-game sounds & music."   "OFF")
option(BACKTRACE    "Support for printing stack backtraces on crash"   "ON")
option(LIBBACKTRACE "Print backtrace with libbacktrace."    "OFF")
option(USE_HOME_DIR "Use user's home directory for save files."   "ON")
option(LOCALIZE     "Support for language localizations. Also enable UTF support."   "ON")
option(LANGUAGES    "Compile localization files for specified languages."   "")
option(DYNAMIC_LINKING "Use dynamic linking. Or use static to remove MinGW dependency instead."   "ON")
option(JSON_FORMAT  "Build JSON formatter" "OFF")
option(CATA_CLANG_TIDY_PLUGIN "Build Cata's custom clang-tidy plugin" "OFF")
set(CATA_CLANG_TIDY_INCLUDE_DIR "" CACHE STRING "Path to internal clang-tidy headers required for plugin (e.g. ClangTidy.h)")
set(CATA_CHECK_CLANG_TIDY "" CACHE STRING "Path to check_clang_tidy.py for plugin tests")
set(GIT_BINARY       "" CACHE STRING "Git binary name or path.")
set(PREFIX           "" CACHE STRING "Location of Data & GFX directories")

include(CTest)

include(GetGitRevisionDescription)
git_describe(GIT_VERSION)

MESSAGE("\n * Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.")
MESSAGE("   _________            __                   .__                                ")
MESSAGE("   \\_   ___ \\ _____   _/  |_ _____     ____  |  |   ___.__   ______  _____      ")
MESSAGE("   /    \\  \\/ \\__  \\  \\   __\\\\__  \\  _/ ___\\ |  |  <   |  | /  ___/ /     \\     ")
MESSAGE("   \\     \\____ / __ \\_ |  |   / __ \\_\\  \\___ |  |__ \\___  | \\___ \\ |  Y Y  \\    ")
MESSAGE("    \\______  /\(____  / |__|  \(____  / \\___  >|____/ / ____|/____  >|__|_|  /    ")
MESSAGE("           \\/      \\/             \\/      \\/        \\/          \\/       \\/     ")
MESSAGE("                               --= Dark Days Ahead =--")
MESSAGE("\n * https://cataclysmdda.org/\n")

MESSAGE(STATUS "${PROJECT} build environment -- \n")

MESSAGE(STATUS "Build realm is                : ${CMAKE_SYSTEM_NAME} ${CMAKE_HOST_SYSTEM_PROCESSOR}")

IF(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
ENDIF(NOT CMAKE_BUILD_TYPE)

if (NOT ${GIT_VERSION} MATCHES GIT-NOTFOUND)
    string(REPLACE "-NOTFOUND" "" GIT_VERSION ${GIT_VERSION})
    FILE(WRITE ${CMAKE_SOURCE_DIR}/src/version.h "\#define VERSION \"${GIT_VERSION}\"\n")
    MESSAGE(STATUS "${PROJECT_NAME} build version is : ${GIT_VERSION}\n")
    ADD_DEFINITIONS(-DGIT_VERSION)
ELSE (NOT ${GIT_VERSION} MATCHES GIT-NOTFOUND)
    MESSAGE("")
ENDIF(NOT ${GIT_VERSION} MATCHES GIT-NOTFOUND)

#OS Check Placeholders. Will be used for BINDIST
IF (${CMAKE_SYSTEM_NAME} MATCHES Linux)
    SET(_OS_LINUX_ 1)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES Linux)

IF (${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)
    SET(_OS_FREEBSD_ 1)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)

IF(${CMAKE_SYSTEM_NAME} MATCHES Darwin)
    SET(_OS_DARWIN_ 1)
    SET(LOCALIZE OFF)
    MESSAGE(STATUS "Disable internationalization on Darwin as it is not supported")
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES Darwin)

include(CheckCXXCompilerFlag)

#FIXME: Add dest build choice: m32 for 32 bit or m64 for 64 bit version
#add_definitions("-m32")
#SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -m32")
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -m32")
#SET(CMAKE_SHARED_LIBRARY_C_FLAGS "${CMAKE_SHARED_LIBRARY_C_FLAGS} -m32")
#SET(CMAKE_SHARED_LIBRARY_CXX_FLAGS "${CMAKE_SHARED_LIBRARY_CXX_FLAGS} -m32")

IF (NOT DYNAMIC_LINKING)
    SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a;.dll.a")
    SET(BUILD_SHARED_LIBRARIES OFF)
    check_cxx_compiler_flag (-static HAVE_STATIC_FLAG)
    IF(HAVE_STATIC_FLAG)
      SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
    ENDIF(HAVE_STATIC_FLAG)
    # Workaround for cmake link library guesser
    SET(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)       # remove -Wl,-Bdynamic
    SET(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
    SET(CMAKE_SHARED_LIBRARY_C_FLAGS)         # remove -fPIC
    SET(CMAKE_SHARED_LIBRARY_CXX_FLAGS)
    SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS)    # remove -rdynamic
    SET(CMAKE_SHARED_LIBRARY_LINK_CXX_FLAGS)
ELSE (NOT DYNAMIC_LINKING)
    IF(MINGW AND NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      # Avoid depending on MinGW runtime DLLs
      SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static-libgcc -static-libstdc++")
    ENDIF(MINGW AND NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
ENDIF (NOT DYNAMIC_LINKING)

# System specific actions
IF (${CMAKE_SYSTEM_NAME} MATCHES Linux OR ${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)
    IF(NOT DATA_PREFIX)
      SET( DATA_PREFIX ${CMAKE_INSTALL_PREFIX}/share/cataclysm-dda)
    ENDIF(NOT DATA_PREFIX)
    IF(NOT LOCALE_DIR)
      SET( LOCALE_DIR ${CMAKE_INSTALL_PREFIX}/share/locale)
    ENDIF(NOT LOCALE_DIR)
    IF(NOT BIN_PREFIX)
      SET( BIN_PREFIX ${CMAKE_INSTALL_PREFIX}/bin)
    ENDIF(NOT BIN_PREFIX)
    IF(NOT DESKTOP_ENTRY_PATH)
      SET( DESKTOP_ENTRY_PATH ${CMAKE_INSTALL_PREFIX}/share/applications)
    ENDIF(NOT DESKTOP_ENTRY_PATH)
    IF(NOT PIXMAPS_ENTRY_PATH)
      SET( PIXMAPS_ENTRY_PATH ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor)
    ENDIF(NOT PIXMAPS_ENTRY_PATH)
    IF(NOT PIXMAPS_UNITY_ENTRY_PATH)
      SET( PIXMAPS_UNITY_ENTRY_PATH ${CMAKE_INSTALL_PREFIX}/share/icons/ubuntu-mono-dark)
    ENDIF(NOT PIXMAPS_UNITY_ENTRY_PATH)
    IF(NOT MANPAGE_ENTRY_PATH)
      SET( MANPAGE_ENTRY_PATH ${CMAKE_INSTALL_PREFIX}/share/man)
    ENDIF(NOT MANPAGE_ENTRY_PATH)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES Linux OR ${CMAKE_SYSTEM_NAME} MATCHES FreeBSD)

IF (${CMAKE_SYSTEM_NAME} MATCHES Windows)
    IF(NOT DATA_PREFIX)
      SET(DATA_PREFIX ${CMAKE_INSTALL_PREFIX})
    ENDIF(NOT DATA_PREFIX)
    IF(NOT LOCALE_DIR)
      SET(LOCALE_DIR ${CMAKE_INSTALL_PREFIX})
    ENDIF(NOT LOCALE_DIR)
    IF(NOT BIN_PREFIX)
      SET(BIN_PREFIX ${CMAKE_INSTALL_PREFIX})
    ENDIF(NOT BIN_PREFIX)
ENDIF (${CMAKE_SYSTEM_NAME} MATCHES Windows)


MESSAGE(STATUS "${PROJECT_NAME} build options --\n")

# Preset variables
IF(NOT LANGUAGES)
    # English is included to workaround a libintl bug that affects performance
    # on MinGW targets. See lang/CMakeList.txt for more information.
    SET (LANGUAGES en de es_AR es_ES fr it_IT ja ko pt_BR ru zh_CN zh_TW)
ENDIF(NOT LANGUAGES)

IF (GIT_BINARY)
    SET(GIT_EXECUTABLE ${GIT_BINARY})
ELSE (GIT_BINARY)
    FIND_PACKAGE(Git)
    IF (NOT GIT_FOUND)
      MESSAGE(WARNING "Git binary not found. Build version will be set to NULL. Install Git package or use -DGIT_BINARY to set path to git binary.")
    ENDIF (NOT GIT_FOUND)
ENDIF (GIT_BINARY)

IF (PREFIX)
    ADD_DEFINITIONS(-DPREFIX=${PREFIX})
ENDIF (PREFIX)

# Can't compile curses and tiles build's at same time
IF(TILES)
    SET(CURSES OFF)
ENDIF(TILES)

# Set build types and display info
IF(CMAKE_BUILD_TYPE STREQUAL Debug)
    MESSAGE("\n")
    MESSAGE(STATUS "Build ${PROJECT} in development mode --\n")
    MESSAGE(STATUS "Binaries will be located in: " ${CMAKE_SOURCE_DIR})
    SET(CMAKE_VERBOSE_MAKEFILE ON)
    # Since CataclysmDDA does not respect PREFIX for development builds
    # and has funny path handlers, we should create resulting Binaries
    # in the source directory
    SET(CMAKE_RUNTIME_OUTPUT_DIRECTORY
     ${CMAKE_SOURCE_DIR}
      CACHE PATH "Single Directory for all Executables."
    )
    SET(BIN_PREFIX ${CMAKE_SOURCE_DIR})
ELSE (CMAKE_BUILD_TYPE STREQUAL Debug)
    MESSAGE(STATUS "CMAKE_INSTALL_PREFIX          : ${CMAKE_INSTALL_PREFIX}")
    MESSAGE(STATUS "BIN_PREFIX                    : ${BIN_PREFIX}")
    MESSAGE(STATUS "DATA_PREFIX                   : ${DATA_PREFIX}")
    IF(LOCALIZE)
      MESSAGE(STATUS "LOCALE_PATH                   : ${LOCALE_DIR}")
    ENDIF(LOCALIZE)
    MESSAGE(STATUS "DESKTOP_ENTRY_PATH            : ${DESKTOP_ENTRY_PATH}")
    MESSAGE(STATUS "PIXMAPS_ENTRY_PATH            : ${PIXMAPS_ENTRY_PATH}")
    MESSAGE(STATUS "PIXMAPS_UNITY_ENTRY_PATH      : ${PIXMAPS_UNITY_ENTRY_PATH}")
    MESSAGE(STATUS "MANPAGE_ENTRY_PATH            : ${MANPAGE_ENTRY_PATH}\n")
    ADD_DEFINITIONS(-DRELEASE)
    # Use PREFIX as storage of data,gfx, etc.. Useful only on *nix OS.
    IF (PREFIX AND NOT WIN32)
      ADD_DEFINITIONS(-DDATA_DIR_PREFIX)
    ENDIF (PREFIX AND NOT WIN32)
ENDIF (CMAKE_BUILD_TYPE STREQUAL Debug)

    MESSAGE(STATUS "GIT_BINARY                    : ${GIT_EXECUTABLE}")
    MESSAGE(STATUS "DYNAMIC_LINKING               : ${DYNAMIC_LINKING}")
    MESSAGE(STATUS "TILES                         : ${TILES}")
    MESSAGE(STATUS "CURSES                        : ${CURSES}")
    MESSAGE(STATUS "SOUND                         : ${SOUND}")
    MESSAGE(STATUS "BACKTRACE                     : ${BACKTRACE}")
    MESSAGE(STATUS "LOCALIZE                      : ${LOCALIZE}")
    MESSAGE(STATUS "USE_HOME_DIR                  : ${USE_HOME_DIR}\n")

    MESSAGE(STATUS "LANGUAGES                     : ${LANGUAGES}\n")

    MESSAGE(STATUS "See INSTALL file for details and more info --\n")

IF(MSVC)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
      add_definitions(-D_AMD64_)
    else()
      add_definitions(-D_X86_)
    endif()
ELSE()
    SET(CATA_WARNINGS
      "-Werror -Wall -Wextra \
       -Wformat-signedness \
       -Wlogical-op \
       -Wmissing-declarations \
       -Wmissing-noreturn \
       -Wnon-virtual-dtor \
       -Wold-style-cast \
       -Woverloaded-virtual \
       -Wpedantic \
       -Wsuggest-override \
       -Wunused-macros \
       -Wzero-as-null-pointer-constant \
       -Wno-unknown-warning-option")
    IF (NOT ${CMAKE_SYSTEM_NAME} MATCHES Windows)
        SET(CATA_WARNINGS "${CATA_WARNINGS} -Wredundant-decls")
    ENDIF()
    # Compact the whitespace in the warning string
    string(REGEX REPLACE "[\t ]+" " " CATA_WARNINGS "${CATA_WARNINGS}")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CATA_WARNINGS}")
    SET(CMAKE_CXX_FLAGS_DEBUG "-Og -g")
ENDIF()

SET(CMAKE_CXX_STANDARD 14)

# Force out-of-source build
IF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    MESSAGE(FATAL_ERROR
      "This project requires an out of source build. Remove the file 'CMakeCache.txt' found in this directory before continuing, create a separate build
       directory and run 'cmake [options] <srcs>' from there.\nSee INSTALL file for details and more info\n"
    )
ENDIF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

#SET(THREADS_USE_PTHREADS_WIN32 True)
SET(CMAKE_THREAD_PREFER_PTHREAD True)
FIND_PACKAGE(Threads REQUIRED)

# Check for build types and libraries
IF(TILES)
    # Find SDL, SDL_ttf & SDL_image for graphical install
    MESSAGE(STATUS "Searching for SDL2 library --")
    FIND_PACKAGE(SDL2)
    IF(NOT SDL2_FOUND)
      MESSAGE(FATAL_ERROR
          "This project requires SDL2 to be installed to be compiled in graphical mode. Please install the SDL2 development libraries, or try compiling 
           without the -DTILES=1 for a text only compilation.\nSee INSTALL file for details and more info\n"
      )
    ENDIF(NOT SDL2_FOUND)

    IF (NOT DYNAMIC_LINKING)
      # SDL, SDL_Image, SDL_ttf deps are required for static build
      MESSAGE(STATUS "Searching for SDL deps libraries --")
      FIND_PACKAGE(Freetype REQUIRED)
      FIND_PACKAGE(PNG REQUIRED)
      FIND_PACKAGE(JPEG REQUIRED)
      FIND_PACKAGE(ZLIB REQUIRED)
      FIND_PACKAGE(BZip2 REQUIRED)
    ENDIF (NOT DYNAMIC_LINKING)

    MESSAGE(STATUS "Searching for SDL2_TTF library --")
    FIND_PACKAGE(SDL2_ttf)
    IF(NOT SDL2_TTF_FOUND)
      MESSAGE(FATAL_ERROR
        "This project requires SDL2_ttf to be installed to be compiled in graphical mode. Please install the SDL2_ttf development libraries, or try
         compiling without the -DTILES=1 for a text only compilation.\nSee INSTALL file for details and moreinfo\n"
      )

=== Makefile ===
# vim: set expandtab tabstop=4 softtabstop=2 shiftwidth=2:
# Platforms:
# Linux/Cygwin native
#   (don't need to do anything)
# Linux 64-bit
#   make NATIVE=linux64
# Linux 32-bit
#   make NATIVE=linux32
# Linux cross-compile to Win32
#   make CROSS=i686-pc-mingw32-
#   or make CROSS=i586-mingw32msvc-
#   or whichever prefix your crosscompiler uses
#      as long as its name contains mingw32
# Linux cross-compile to OSX with osxcross
#   make CROSS=x86_64-apple-darwin15-
#        NATIVE=osx
#        CLANG=1
#        OSXCROSS=1
#        LIBSDIR=../libs
#        FRAMEWORKSDIR=../Frameworks
# Win32 (non-Cygwin)
#   Run: make NATIVE=win32
# OS X
#   Run: make NATIVE=osx OSX_MIN=10.12
#     It is highly recommended to supply OSX_MIN > 10.11
#     otherwise optimizations are automatically disabled with -O0

# Build types:
# Debug (no optimizations)
#  Default
# ccache (use compilation caches)
#  make CCACHE=1
# Release (turn on optimizations)
#  make RELEASE=1
# Tiles (uses SDL rather than ncurses)
#  make TILES=1
# Sound (requires SDL, so TILES must be enabled)
#  make TILES=1 SOUND=1
# Disable gettext, on some platforms the dependencies are hard to wrangle.
#  make LOCALIZE=0
# Disable backtrace support, not available on all platforms
#  make BACKTRACE=0
# Use libbacktrace. Only has effect if BACKTRACE=1. (currently only for MinGW builds)
#  make LIBBACKTRACE=1
# Compile localization files for specified languages
#  make localization LANGUAGES="<lang_id_1>[ lang_id_2][ ...]"
#  (for example: make LANGUAGES="zh_CN zh_TW" for Chinese)
#  make localization LANGUAGES=all
#  (for every .po file in lang/po)
#  Special note for MinGW: due to a libintl bug (https://savannah.gnu.org/bugs/index.php?58006),
#  using English without a `.mo` file would cause significant slow down on MinGW
#  targets. In such case you can compile a `.mo` file for English using `make LANGUAGES="en"`.
#  `make LANGUAGE="all"` also compiles a `.mo` file for English in addition to other languages.
# Enable sanitizer (address, undefined, etc.)
#  make SANITIZE=address
# Change mapsize (reality bubble size)
#  make MAPSIZE=<size>
# Adjust names of build artifacts (for example to allow easily toggling between build types).
#  make BUILD_PREFIX="release-"
# Generate a build artifact prefix from the other build flags.
#  make AUTO_BUILD_PREFIX=1
# Install to system directories.
#  make install
# Use user's XDG base directories for save files and configs.
#  make USE_XDG_DIR=1
# Use user's home directory for save files.
#  make USE_HOME_DIR=1
# Use dynamic linking (requires system libraries).
#  make DYNAMIC_LINKING=1
# Use MSYS2 as the build environment on Windows
#  make MSYS2=1
# Turn off all optimizations, even debug-friendly optimizations
#  make NOOPT=1
# Astyle all source files.
#  make astyle
# Check if source files are styled properly.
#  make astyle-check
# Style the whitelisted json files (maintain the current level of styling).
#  make style-json
# Style all json files using the current rules (don't PR this, it's too many changes at once).
#  make style-all-json
# Disable astyle of source files.
# make ASTYLE=0
# Disable format check of whitelisted json files.
# make LINTJSON=0
# Disable building and running tests.
# make RUNTESTS=0

# comment these to toggle them as one sees fit.
# DEBUG is best turned on if you plan to debug in gdb -- please do!
# PROFILE is for use with gprof or a similar program -- don't bother generally.
# RELEASE_FLAGS is flags for release builds.
RELEASE_FLAGS =
WARNINGS = \
  -Werror -Wall -Wextra \
  -Wformat-signedness \
  -Wlogical-op \
  -Wmissing-declarations \
  -Wmissing-noreturn \
  -Wnon-virtual-dtor \
  -Wold-style-cast \
  -Woverloaded-virtual \
  -Wpedantic \
  -Wsuggest-override \
  -Wunused-macros \
  -Wzero-as-null-pointer-constant \
  -Wno-unknown-warning-option
# Uncomment below to disable warnings
#WARNINGS = -w
DEBUGSYMS = -g
#PROFILE = -pg
#OTHERS = -O3
#DEFINES = -DNDEBUG

# Tells ccache to keep comments, as they can be meaningful to the compiler (as to suppress warnings).
export CCACHE_COMMENTS=1

# Disable debug. Comment this out to get logging.
#DEFINES = -DENABLE_LOGGING

# Limit debug to level. Comment out all for all levels.
#DEFINES += -DDEBUG_INFO
#DEFINES += -DDEBUG_WARNING
#DEFINES += -DDEBUG_ERROR
#DEFINES += -DDEBUG_PEDANTIC_INFO

# Limit debug to section. Comment out all for all levels.
#DEFINES += -DDEBUG_ENABLE_MAIN
#DEFINES += -DDEBUG_ENABLE_MAP
#DEFINES += -DDEBUG_ENABLE_MAP_GEN
#DEFINES += -DDEBUG_ENABLE_GAME

# Explicitly let 'char' to be 'signed char' to fix #18776
OTHERS += -fsigned-char

VERSION = 0.E

TARGET_NAME = cataclysm
TILES_TARGET_NAME = $(TARGET_NAME)-tiles

TARGET = $(BUILD_PREFIX)$(TARGET_NAME)
TILESTARGET = $(BUILD_PREFIX)$(TILES_TARGET_NAME)
ifdef TILES
  APPTARGET = $(TILESTARGET)
else
  APPTARGET = $(TARGET)
endif
W32TILESTARGET = $(BUILD_PREFIX)$(TILES_TARGET_NAME).exe
W32TARGET = $(BUILD_PREFIX)$(TARGET_NAME).exe
CHKJSON_BIN = $(BUILD_PREFIX)chkjson
BINDIST_DIR = $(BUILD_PREFIX)bindist
BUILD_DIR = $(CURDIR)
SRC_DIR = src
LOCALIZE = 1
ASTYLE_BINARY = astyle

# Enable astyle by default
ifndef ASTYLE
  ASTYLE = 1
endif

# Enable json format check by default
ifndef LINTJSON
  LINTJSON = 1
endif

# Enable running tests by default
ifndef RUNTESTS
  RUNTESTS = 1
endif

# Auto-detect MSYS2
ifdef MSYSTEM
  MSYS2 = 1
endif

# Determine JSON formatter binary name
ifeq ($(MSYS2), 1)
  JSON_FORMATTER_BIN=tools/format/json_formatter.exe
else
  JSON_FORMATTER_BIN=tools/format/json_formatter.cgi
endif

# Enable backtrace by default
ifndef BACKTRACE
  # ...except not on native Windows builds, because the relevant headers are
  # probably not available
  ifneq ($(MSYS2), 1)
    BACKTRACE = 1
  endif
endif
ifdef BACKTRACE
  # Also enable libbacktrace on cross-compilation to Windows
  ifndef LIBBACKTRACE
    ifneq (,$(findstring mingw32,$(CROSS)))
      LIBBACKTRACE = 1
    endif
  endif
endif

ifeq ($(RUNTESTS), 1)
  TESTS = tests
endif

# tiles object directories are because gcc gets confused
# Appears that the default value of $LD is unsuitable on most systems

# when preprocessor defines change, but the source doesn't
ODIR = $(BUILD_PREFIX)obj
ODIRTILES = $(BUILD_PREFIX)obj/tiles
W32ODIR = $(BUILD_PREFIX)objwin
W32ODIRTILES = $(W32ODIR)/tiles

ifdef AUTO_BUILD_PREFIX
  BUILD_PREFIX = $(if $(RELEASE),release-)$(if $(DEBUG_SYMBOLS),symbol-)$(if $(TILES),tiles-)$(if $(SOUND),sound-)$(if $(LOCALIZE),local-)$(if $(BACKTRACE),back-$(if $(LIBBACKTRACE),libbacktrace-))$(if $(SANITIZE),sanitize-)$(if $(MAPSIZE),map-$(MAPSIZE)-)$(if $(USE_XDG_DIR),xdg-)$(if $(USE_HOME_DIR),home-)$(if $(DYNAMIC_LINKING),dynamic-)$(if $(MSYS2),msys2-)
  export BUILD_PREFIX
endif

OS  = $(shell uname -s)

# if $(OS) contains 'BSD'
ifneq ($(findstring BSD,$(OS)),)
  BSD = 1
endif

# This sets CXX and so must be up here
ifdef CLANG
  # Allow setting specific CLANG version
  ifeq ($(CLANG), 1)
    CLANGCMD = clang++
  else
    CLANGCMD = $(CLANG)
  endif
  ifeq ($(NATIVE), osx)
    USE_LIBCXX = 1
  endif
  ifdef USE_LIBCXX
    OTHERS += -stdlib=libc++
    LDFLAGS += -stdlib=libc++
  endif
  ifdef CCACHE
    CXX = CCACHE_CPP2=1 ccache $(CROSS)$(CLANGCMD)
    LD  = CCACHE_CPP2=1 ccache $(CROSS)$(CLANGCMD)
  else
    CXX = $(CROSS)$(CLANGCMD)
    LD  = $(CROSS)$(CLANGCMD)
  endif
else
  # Compiler version & target machine - used later for MXE ICE workaround
  ifdef CROSS
    CXXVERSION := $(shell $(CROSS)$(CXX) --version | grep -i gcc | sed 's/^.* //g')
    CXXMACHINE := $(shell $(CROSS)$(CXX) -dumpmachine)
  endif

  # Expand at reference time to avoid recursive reference
  OS_COMPILER := $(CXX)
  # Appears that the default value of $LD is unsuitable on most systems
  OS_LINKER := $(CXX)
  ifdef CCACHE
    CXX = ccache $(CROSS)$(OS_COMPILER)
    LD  = ccache $(CROSS)$(OS_LINKER)
  else
    CXX = $(CROSS)$(OS_COMPILER)
    LD  = $(CROSS)$(OS_LINKER)
  endif
endif

STRIP = $(CROSS)strip
RC  = $(CROSS)windres
AR  = $(CROSS)ar

# We don't need scientific precision for our math functions, this lets them run much faster.
CXXFLAGS += -ffast-math
LDFLAGS += $(PROFILE)

ifneq ($(SANITIZE),)
  SANITIZE_FLAGS := -fsanitize=$(SANITIZE) -fno-sanitize-recover=all
  CXXFLAGS += $(SANITIZE_FLAGS)
  LDFLAGS += $(SANITIZE_FLAGS)
endif

# enable optimizations. slow to build
ifdef RELEASE
  ifeq ($(NATIVE), osx)
    ifdef OSXCROSS
      OPTLEVEL = -O0
    else ifeq ($(shell expr $(OSX_MIN) \<= 10.11), 1)
      OPTLEVEL = -O0
    else
      ifeq ($(shell $(CXX) -E -Os - < /dev/null > /dev/null 2>&1 && echo fos),fos)
        OPTLEVEL = -Os
      else
        OPTLEVEL = -O3
      endif
    endif
  else
    # MXE ICE Workaround
    # known bad on 4.9.3 and 4.9.4, if it gets fixed this could include a version test too
    ifeq ($(CXXMACHINE), x86_64-w64-mingw32.static)
      OPTLEVEL = -O3
    else
      OPTLEVEL = -Os
    endif
  endif

  ifdef LTO
    ifdef CLANG
      # LLVM's LTO will complain if the optimization level isn't between O0 and
      # O3 (inclusive)
      OPTLEVEL = -O3
    endif
  endif
  CXXFLAGS += $(OPTLEVEL)

  ifdef LTO
    ifeq ($(NATIVE), osx)
      ifdef CLANG
        LTOFLAGS += -flto=full
      endif
    else
      LDFLAGS += -fuse-ld=gold # This breaks in OS X because gold can only produce ELF binaries, not Mach
    endif

    ifdef CLANG
      LTOFLAGS += -flto
    else
      LTOFLAGS += -flto=jobserver -flto-odr-type-merging
    endif
  endif
  CXXFLAGS += $(LTOFLAGS)

  # OTHERS += -mmmx -m3dnow -msse -msse2 -msse3 -mfpmath=sse -mtune=native
  # OTHERS += -march=native # Uncomment this to build an optimized binary for your machine only
  
  # Strip symbols, generates smaller executable.
  OTHERS += $(RELEASE_FLAGS)
  DEBUG =
  ifndef DEBUG_SYMBOLS
    DEBUGSYMS =
  endif
  DEFINES += -DRELEASE
  # Check for astyle or JSON regressions on release builds.
  ifeq ($(ASTYLE), 1)
    CHECKS += astyle-check
  endif
  ifeq ($(LINTJSON), 1)
    CHECKS += style-json
  endif
endif

ifndef RELEASE
  ifdef NOOPT
    # While gcc claims to include all information required for
    # debugging at -Og, at least with gcc 8.3, control flow
    # doesn't move line-by-line at -Og.  Provide a command-line
    # way to turn off optimization (make NOOPT=1) entirely.
    OPTLEVEL = -O0
  else
    ifeq ($(shell $(CXX) -E -Og - < /dev/null > /dev/null 2>&1 && echo fog),fog)
      OPTLEVEL = -Og
    else
      OPTLEVEL = -O0
    endif
  endif
  CXXFLAGS += $(OPTLEVEL)
endif

ifeq ($(shell sh -c 'uname -o 2>/dev/null || echo not'),Cygwin)
  OTHERS += -std=gnu++14
else
  OTHERS += -std=c++14
endif

ifeq ($(CYGWIN),1)
WARNINGS += -Wimplicit-fallthrough=0
endif

CXXFLAGS += $(WARNINGS) $(DEBUG) $(DEBUGSYMS) $(PROFILE) $(OTHERS) -MMD -MP
TOOL_CXXFLAGS = -DCATA_IN_TOOL

BINDIST_EXTRAS += README.md data doc LICENSE.txt LICENSE-OFL-Terminus-Font.txt VERSION.txt $(JSON_FORMATTER_BIN)
BINDIST    = $(BUILD_PREFIX)cataclysmdda-$(VERSION).tar.gz
W32BINDIST = $(BUILD_PREFIX)cataclysmdda-$(VERSION).zip
BINDIST_CMD    = tar --transform=s@^$(BINDIST_DIR)@cataclysmdda-$(VERSION)@ -czvf $(BINDIST) $(BINDIST_DIR)
W32BINDIST_CMD = cd $(BINDIST_DIR) && zip -r ../$(W32BINDIST) * && cd $(BUILD_DIR)


# Check if called without a special build target
ifeq ($(NATIVE),)
  ifeq ($(CROSS),)
    ifeq ($(shell sh -c 'uname -o 2>/dev/null || echo not'),Cygwin)
      DEFINES += -DCATA_NO_CPP11_STRING_CONVERSIONS
      TARGETSYSTEM=CYGWIN
    else
      TARGETSYSTEM=LINUX
    endif
  endif
endif

# Linux 64-bit
ifeq ($(NATIVE), linux64)
  CXXFLAGS += -m64
  LDFLAGS += -m64
  TARGETSYSTEM=LINUX
  ifdef GOLD
    CXXFLAGS += -fuse-ld=gold
    LDFLAGS += -fuse-ld=gold
  endif
else
  # Linux 32-bit
  ifeq ($(NATIVE), linux32)
    CXXFLAGS += -m32
    LDFLAGS += -m32
    TARGETSYSTEM=LINUX
    ifdef GOLD
      CXXFLAGS += -fuse-ld=gold
      LDFLAGS += -fuse-ld=gold
    endif
  endif
endif

# OSX
ifeq ($(NATIVE), osx)
  ifdef CLANG
    OSX_MIN = 10.7
  else
    OSX_MIN = 10.5
  endif
  DEFINES += -DMACOSX

=== data/CMakeLists.txt ===
# Cataclysm data files
cmake_minimum_required(VERSION 3.1.4)

SET(CATACLYSM_DATA_DIRS
    ${CMAKE_SOURCE_DIR}/data/font
    ${CMAKE_SOURCE_DIR}/data/json
    ${CMAKE_SOURCE_DIR}/data/mods
    ${CMAKE_SOURCE_DIR}/data/names
    ${CMAKE_SOURCE_DIR}/data/raw
    ${CMAKE_SOURCE_DIR}/data/motd
    ${CMAKE_SOURCE_DIR}/data/credits
    ${CMAKE_SOURCE_DIR}/data/title
)

IF(SOUND)
    SET(CATACLYSM_DATA_DIRS
      ${CATACLYSM_DATA_DIRS}
      ${CMAKE_SOURCE_DIR}/data/sound
    )
ENDIF(SOUND)

IF(TILES)
    SET(CATACLYSM_DATA_DIRS
      ${CATACLYSM_DATA_DIRS}
      ${CMAKE_SOURCE_DIR}/gfx
    )
ENDIF(TILES)

SET(CATACLYSM_DATA_FILES
    ${CMAKE_SOURCE_DIR}/data/changelog.txt
    ${CMAKE_SOURCE_DIR}/data/cataicon.ico
    ${CMAKE_SOURCE_DIR}/data/fontdata.json
    ${CMAKE_SOURCE_DIR}/LICENSE.txt
)

IF(RELEASE)
    install(DIRECTORY ${CATACLYSM_DATA_DIRS} DESTINATION ${DATA_PREFIX})
    install(FILES ${CATACLYSM_DATA_FILES} DESTINATION ${DATA_PREFIX})
ENDIF(RELEASE)

=== lang/CMakeLists.txt ===
MESSAGE(STATUS "Process LANGUAGES variable --\n")

FIND_PACKAGE(Gettext)

IF (NOT GETTEXT_FOUND)
    MESSAGE(FATAL_ERROR
            "Gettext not found. Install gettext package or disable
             localization with: -DLOCALIZE=OFF \nSee INSTALL file for details and more info\n"
    )
ENDIF (NOT GETTEXT_FOUND)

foreach (LANG ${LANGUAGES})
    MESSAGE(STATUS "Add translation for ${LANG}: ${LANG}.po")
endforeach ()
MESSAGE("\n")

# Extract json strings

add_custom_target (
    extract_string
    COMMAND python lang/extract_json_strings.py
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

# Generate cataclysm-dda.pot
add_custom_target (
    translations
    COMMAND xgettext --default-domain="cataclysm-dda"
                     --sort-by-file
                     --add-comments="~"
                     --output="${CMAKE_SOURCE_DIR}/lang/po/cataclysm-dda.pot"
                     --keyword="_"
                     --keyword="pgettext:1c,2"
                     --keyword="ngettext:1,2"
                     --from-code="UTF-8"
                     ${CMAKE_SOURCE_DIR}/src/*.cpp
                     ${CMAKE_SOURCE_DIR}/src/*.h
                     ${CMAKE_SOURCE_DIR}/lang/json/*.py
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    DEPENDS extract_string
)

add_custom_target (
    translations_prepare
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

# Auto-Compile translation on release builds only
IF (RELEASE)
    add_custom_target (
      translations_compile
      ALL
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      DEPENDS translations_prepare
    )
ELSE (RELEASE)
    add_custom_target (
      translations_compile
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      DEPENDS translations_prepare
    )
ENDIF (RELEASE)

foreach (LANG ${LANGUAGES})
    add_custom_command (
      TARGET translations_prepare
      PRE_BUILD
      COMMAND ${CMAKE_COMMAND}
              -E make_directory ${CMAKE_SOURCE_DIR}/lang/mo/${LANG}/LC_MESSAGES
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
    IF (${LANG} STREQUAL en)
      # English is special: we do not actually need translation for English, but
      # due to a libintl bug (https://savannah.gnu.org/bugs/index.php?58006),
      # gettext would be extremely slow on MinGW targets if we do not compile a
      # .mo file.
      add_custom_command (
        TARGET translations_prepare
        PRE_BUILD
        COMMAND msgen ${CMAKE_SOURCE_DIR}/lang/po/cataclysm-dda.pot --output-file=${CMAKE_SOURCE_DIR}/lang/po/en.po
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      )
    ENDIF (${LANG} STREQUAL en)
    add_custom_command (
      TARGET translations_compile
      PRE_BUILD
      COMMAND 
      ${GETTEXT_MSGFMT_EXECUTABLE} -f ${CMAKE_SOURCE_DIR}/lang/po/${LANG}.po
             -o ${CMAKE_SOURCE_DIR}/lang/mo/${LANG}/LC_MESSAGES/cataclysm-dda.mo
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    )
    IF(RELEASE)
      IF (${CMAKE_SYSTEM_NAME} MATCHES Windows)
        #install(DIRECTORY ${CMAKE_SOURCE_DIR}/lang/mo/${LANG} DESTINATION ${DATA_PREFIX})
      ELSE (${CMAKE_SYSTEM_NAME} MATCHES Windows)
        install(DIRECTORY ${CMAKE_SOURCE_DIR}/lang/mo/${LANG} DESTINATION ${LOCALE_DIR})
      ENDIF (${CMAKE_SYSTEM_NAME} MATCHES Windows)
    ENDIF(RELEASE)
endforeach()

=== src/CMakeLists.txt ===
# Cataclysm DDA client
cmake_minimum_required(VERSION 3.1.4)

SET(MAIN_CPP ${CMAKE_SOURCE_DIR}/src/main.cpp)
SET(RESOURCE_RC ${CMAKE_SOURCE_DIR}/src/resource.rc)

FILE(GLOB CATACLYSM_DDA_SOURCES
    ${CMAKE_SOURCE_DIR}/src/*.cpp
)

LIST(REMOVE_ITEM CATACLYSM_DDA_SOURCES ${MAIN_CPP})

FILE(GLOB CATACLYSM_DDA_HEADERS
    ${CMAKE_SOURCE_DIR}/src/*.h
)

# Get GIT version strings
ADD_CUSTOM_TARGET(
    get_version
    DEPENDS ${CMAKE_SOURCE_DIR}/src/version.h
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

ADD_CUSTOM_COMMAND (
    OUTPUT ${CMAKE_SOURCE_DIR}/src/version.h
    COMMAND ${CMAKE_COMMAND}
      -D SRC=${CMAKE_SOURCE_DIR}/src/version.h.in
      -D DST=${CMAKE_SOURCE_DIR}/src/version.h
      -D GIT_EXECUTABLE=${GIT_EXECUTABLE}
      -P ${CMAKE_SOURCE_DIR}/src/version.cmake
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
)

# Build tiles version if requested
IF(TILES)
    add_library(libcataclysm-tiles STATIC
      ${CATACLYSM_DDA_SOURCES}
      ${CATACLYSM_DDA_HEADERS}
    )
    target_include_directories(libcataclysm-tiles INTERFACE ${CMAKE_SOURCE_DIR}/src)

    IF(WIN32)
      ADD_DEFINITIONS(-DUSE_WINMAIN)
      ADD_EXECUTABLE(cataclysm-tiles WIN32
        ${MAIN_CPP}
        ${RESOURCE_RC}
      )
    ELSE(WIN32)
      ADD_EXECUTABLE(cataclysm-tiles
        ${MAIN_CPP}
      )
    ENDIF(WIN32)

    ADD_DEPENDENCIES(libcataclysm-tiles get_version)

    target_link_libraries(cataclysm-tiles libcataclysm-tiles)
    target_compile_definitions(libcataclysm-tiles PUBLIC TILES )

    IF (LOCALIZE)
      target_include_directories(libcataclysm-tiles PUBLIC
        ${LIBINTL_INCLUDE_DIR}
        ${ICONV_INCLUDE_DIR}
      )
      target_link_libraries(libcataclysm-tiles
        ${LIBINTL_LIBRARIES}
        ${ICONV_LIBRARIES}
      )
    ENDIF (LOCALIZE)

    IF(CMAKE_USE_PTHREADS_INIT)
      target_compile_options(libcataclysm-tiles PUBLIC "-pthread")
    ENDIF(CMAKE_USE_PTHREADS_INIT)

    IF(CMAKE_THREAD_LIBS_INIT)
      target_link_libraries(libcataclysm-tiles ${CMAKE_THREAD_LIBS_INIT})
    ENDIF(CMAKE_THREAD_LIBS_INIT)

    IF (NOT DYNAMIC_LINKING)
      # SDL, SDL_Image, SDL_ttf deps are required for static build
      target_include_directories(libcataclysm-tiles PUBLIC
        ${FREETYPE_INCLUDE_DIRS}
        ${PNG_INCLUDE_DIRS}
        ${JPEG_INCLUDE_DIR}
        ${ZLIB_INCLUDE_DIRS}
        ${BZIP2_INCLUDE_DIR}
      )
      target_link_libraries(libcataclysm-tiles
        ${FREETYPE_LIBRARIES}
        ${PNG_LIBRARIES}
        ${JPEG_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${BZIP2_LIBRARIES}
      )
    ENDIF (NOT DYNAMIC_LINKING)
    target_include_directories(libcataclysm-tiles PUBLIC
      ${SDL2_INCLUDE_DIR}
      ${SDL2_IMAGE_INCLUDE_DIRS}
      ${SDL2_TTF_INCLUDE_DIRS}
    )
    target_link_libraries(libcataclysm-tiles
      ${SDL2_LIBRARY}
      ${SDL2_IMAGE_LIBRARIES}
      ${SDL2_TTF_LIBRARIES}
    )

    IF(SOUND)
      target_compile_definitions(libcataclysm-tiles PUBLIC SDL_SOUND )
      target_include_directories(libcataclysm-tiles PUBLIC ${OGGVORBIS_INCLUDE_DIR})
      target_link_libraries(libcataclysm-tiles ${OGG_LIBRARY})
      target_link_libraries(libcataclysm-tiles ${VORBIS_LIBRARY})
      target_link_libraries(libcataclysm-tiles ${VORBISFILE_LIBRARY})
      target_include_directories(libcataclysm-tiles PUBLIC ${SDL2_MIXER_INCLUDE_DIRS})
      target_link_libraries(libcataclysm-tiles ${SDL2_MIXER_LIBRARIES})
    ENDIF(SOUND)

    IF(WIN32)
      # Global settings for Windows targets (at end)
      target_link_libraries(libcataclysm-tiles gdi32.lib)
      target_link_libraries(libcataclysm-tiles winmm.lib)
      target_link_libraries(libcataclysm-tiles imm32.lib)
      target_link_libraries(libcataclysm-tiles ole32.lib)
      target_link_libraries(libcataclysm-tiles oleaut32.lib)
      target_link_libraries(libcataclysm-tiles version.lib)
      IF (BACKTRACE)
        target_link_libraries(libcataclysm-tiles dbghelp.lib)
        IF(LIBBACKTRACE)
          target_link_libraries(libcataclysm-tiles backtrace)
        ENDIF(LIBBACKTRACE)
      ENDIF(BACKTRACE)
    ENDIF(WIN32)

    IF(RELEASE)
      install(TARGETS cataclysm-tiles DESTINATION ${BIN_PREFIX})
    ENDIF(RELEASE)
ENDIF(TILES)

# Build curses version if requested
IF(CURSES)
    add_library(libcataclysm STATIC
      ${CATACLYSM_DDA_SOURCES}
      ${CATACLYSM_DDA_HEADERS}
    )
    target_include_directories(libcataclysm INTERFACE ${CMAKE_SOURCE_DIR}/src)

    IF(WIN32)
      ADD_EXECUTABLE(cataclysm
        ${MAIN_CPP}
        ${RESOURCE_RC}
      )
    ELSE(WIN32)
      ADD_EXECUTABLE(cataclysm
        ${MAIN_CPP}
      )
    ENDIF(WIN32)

    ADD_DEPENDENCIES(libcataclysm get_version)
    target_link_libraries(cataclysm libcataclysm)

    IF (LOCALIZE)
      target_include_directories(libcataclysm PUBLIC
        ${LIBINTL_INCLUDE_DIR}
        ${ICONV_INCLUDE_DIR}
      )
      target_link_libraries(libcataclysm
        ${LIBINTL_LIBRARIES}
        ${ICONV_LIBRARIES}
      )
    ENDIF (LOCALIZE)

    target_include_directories(libcataclysm PUBLIC ${CURSES_INCLUDE_DIR})
    target_link_libraries(libcataclysm ${CURSES_LIBRARIES})

    IF(CMAKE_USE_PTHREADS_INIT)
      target_compile_options(libcataclysm PUBLIC "-pthread")
    ENDIF(CMAKE_USE_PTHREADS_INIT)

    IF(CMAKE_THREAD_LIBS_INIT)
      target_link_libraries(libcataclysm ${CMAKE_THREAD_LIBS_INIT})
    ENDIF(CMAKE_THREAD_LIBS_INIT)

    IF(WIN32)
      # Global settings for Windows targets (at end)
      target_link_libraries(libcataclysm gdi32.lib)
      target_link_libraries(libcataclysm winmm.lib)
      target_link_libraries(libcataclysm imm32.lib)
      target_link_libraries(libcataclysm ole32.lib)
      target_link_libraries(libcataclysm oleaut32.lib)
      target_link_libraries(libcataclysm version.lib)
      IF (BACKTRACE)
        target_link_libraries(libcataclysm dbghelp.lib)
        IF(LIBBACKTRACE)
          target_link_libraries(libcataclysm backtrace)
        ENDIF(LIBBACKTRACE)
      ENDIF(BACKTRACE)
    ENDIF(WIN32)

    IF(RELEASE)
      install(TARGETS cataclysm DESTINATION ${BIN_PREFIX})
    ENDIF(RELEASE)

ENDIF(CURSES)

IF(MINGW AND NOT RELEASE)
    # Try to Install shared libraries for dev builds
    # Note: It is specific to MSYS2 and uses hardcoded versions so
    # probably it will fail if you run it :)

    # GCC-specific libraries
    find_library(RuntimeLib_GCC_S_DW2_1  "gcc_s_dw2-1")
    find_library(RuntimeLib_STDC_PP_6    "stdc++-6")
    find_library(RuntimeLib_WINPTHREAD_1 "winpthread-1")
    SET(RuntimeLib_GCC_ALL
      ${RuntimeLib_GCC_S_DW2_1}
      ${RuntimeLib_STDC_PP_6}
      ${RuntimeLib_WINPTHREAD_1}
    )
    IF (LOCALIZE)
      find_library(RuntimeLib_iconv  "libiconv-2")
      find_library(RuntimeLib_intl  "libintl-8")
      SET(RuntimeLib_LOCALIZE
        ${RuntimeLib_iconv}
        ${RuntimeLib_intl}
      )
    ENDIF (LOCALIZE)
    IF (TILES)
      # SDL2 can have a varius deps. Here you are the MSYS2 ones...
      find_library(RuntimeLib_SDL2  "SDL2")
      find_library(RuntimeLib_SDL2_IMG  "SDL2_image")
      find_library(RuntimeLib_png  "libpng16-16")
      find_library(RuntimeLib_jpeg  "libjpeg-8")
      find_library(RuntimeLib_jbig  "libjbig-0")
      find_library(RuntimeLib_tiff  "libtiff-5")
      find_library(RuntimeLib_webp  "libwebp-5")
      find_library(RuntimeLib_lzma  "liblzma-5")
      find_library(RuntimeLib_bz2  "libbz2-1")
      find_library(RuntimeLib_zlib  "zlib1")
      find_library(RuntimeLib_hb  "libharfbuzz-0")
      find_library(RuntimeLib_SDL2_TTF  "SDL2_ttf")
      find_library(RuntimeLib_ft  "libfreetype-6")
      find_library(RuntimeLib_glib  "libglib-2.0-0")
      SET(RuntimeLib_SDL
        ${RuntimeLib_SDL2}
        ${RuntimeLib_SDL2_IMG}
        ${RuntimeLib_png}
        ${RuntimeLib_jpeg}
        ${RuntimeLib_jbig}
        ${RuntimeLib_tiff}
        ${RuntimeLib_webp}
        ${RuntimeLib_lzma}
        ${RuntimeLib_bz2}
        ${RuntimeLib_zlib}
        ${RuntimeLib_hb}
        ${RuntimeLib_SDL2_TTF}
        ${RuntimeLib_ft}
        ${RuntimeLib_glib}
      )
      IF(SOUND)
        find_library(RuntimeLib_SDL_SND  "SDL2_mixer")
        find_library(RuntimeLib_flak  "libFLAC-8")
        find_library(RuntimeLib_ogg  "libogg-0")
        find_library(RuntimeLib_flu  "libfluidsynth-1")
        find_library(RuntimeLib_port  "libportaudio-2")
        find_library(RuntimeLib_snd  "libsndfile-1")
        find_library(RuntimeLib_vorb  "libvorbis-0")
        find_library(RuntimeLib_vorb_enc  "libvorbisenc-2")
        find_library(RuntimeLib_vorb_f  "libvorbisfile-3")
        find_library(RuntimeLib_mod  "libmodplug-1")
        find_library(RuntimeLib_mpeg  "smpeg2")
        SET(RuntimeLib_SDL_SOUND
          ${RuntimeLib_SDL_SND}
          ${RuntimeLib_flak}
          ${RuntimeLib_ogg}
          ${RuntimeLib_flu}
          ${RuntimeLib_port}
          ${RuntimeLib_snd}
          ${RuntimeLib_vorb}
          ${RuntimeLib_vorb_enc}
          ${RuntimeLib_vorb_f}
          ${RuntimeLib_mod}
          ${RuntimeLib_mpeg}
        )
      ENDIF(SOUND)
    ENDIF (TILES)
    install(FILES ${RuntimeLib_GCC_ALL}
      ${RuntimeLib_LOCALIZE}
      ${RuntimeLib_SDL}
      ${RuntimeLib_SDL_SOUND}
      DESTINATION ${BIN_PREFIX}
    )
ENDIF(MINGW AND NOT RELEASE)

# vim:noet

=== tests/Makefile ===
# Make any tests, and possibly run them.
# A selection of variables are exported from the master Makefile.

# As each test will have a main function we need to handle this file by file.
# We're using the fairly typical convention that any file ending in _test.cpp
# is a test executable.
SOURCES = $(wildcard *.cpp)
OBJS = $(sort $(SOURCES:%.cpp=$(ODIR)/%.o))

CATA_LIB=../$(BUILD_PREFIX)cataclysm.a

# If you invoke this makefile directly and the parent directory was
# built with BUILD_PREFIX set, you must set it for this invocation as well.
ODIR ?= obj

LDFLAGS += -L.

# Allow use of any header files from cataclysm.
# Catch sections throw unused variable warnings.
# Add no-sign-compare to fix MXE issue when compiling
# Catch also uses "#pragma gcc diagnostic", which is not recognized on some supported compilers.
# Clang and mingw are warning about Catch macros around perfectly normal boolean operations.
CXXFLAGS += -I../src -Wno-unused-variable -Wno-sign-compare -Wno-unknown-pragmas -Wno-parentheses -MMD -MP
CXXFLAGS += -Wall -Wextra

ifeq ($(TARGETSYSTEM), WINDOWS)
  TEST_TARGET = $(BUILD_PREFIX)cata_test.exe
else
  TEST_TARGET = $(BUILD_PREFIX)cata_test
endif

tests: $(TEST_TARGET)

$(TEST_TARGET): $(OBJS) $(CATA_LIB)
	+$(CXX) $(W32FLAGS) -o $@ $(DEFINES) $(OBJS) $(CATA_LIB) $(CXXFLAGS) $(LDFLAGS)

# Iterate over all the individual tests.
check: $(TEST_TARGET)
	cd .. && tests/$(TEST_TARGET) -d yes --rng-seed time

clean:
	rm -rf *obj *objwin
	rm -f *cata_test

#Unconditionally create object directory on invocation.
$(shell mkdir -p $(ODIR))

$(ODIR)/%.o: %.cpp
	$(CXX) $(DEFINES) $(CXXFLAGS) -c $< -o $@

.PHONY: clean check tests

.SECONDARY: $(OBJS)

-include ${OBJS:.o=.d}

=== tools/clang-tidy-plugin/CMakeLists.txt ===
include(ExternalProject)

find_package(LLVM REQUIRED CONFIG)
find_package(Clang REQUIRED CONFIG)

add_library(
    CataAnalyzerPlugin MODULE
    CataTidyModule.cpp
    JsonTranslationInputCheck.cpp
    NoLongCheck.cpp
    NoStaticGettextCheck.cpp
    PointInitializationCheck.cpp
    SimplifyPointConstructorsCheck.cpp
    StringLiteralIterator.cpp
    TestFilenameCheck.cpp
    TextStyleCheck.cpp
    TranslatorCommentsCheck.cpp
    UseNamedPointConstantsCheck.cpp
    UsePointApisCheck.cpp
    UsePointArithmeticCheck.cpp
    Utils.cpp
    XYCheck.cpp
    )

target_include_directories(
    CataAnalyzerPlugin SYSTEM PRIVATE
    ${LLVM_INCLUDE_DIRS} ${CLANG_INCLUDE_DIRS})

if ("${CATA_CLANG_TIDY_INCLUDE_DIR}" STREQUAL "")
    SET(ctps_releases
        https://github.com/jbytheway/clang-tidy-plugin-support/releases/download)
    SET(ctps_version llvm-8.0.1-r12)
    SET(ctps_src
        ${CMAKE_CURRENT_BINARY_DIR}/clang-tidy-plugin-support)

    ExternalProject_Add(
        clang-tidy-plugin-support
        URL ${ctps_releases}/${ctps_version}/clang-tidy-plugin-support-${ctps_version}.tar.xz
        URL_HASH SHA256=00ffab0df11250f394830735514c62ae787bd2eb6eb9d5e97471206d270c54e2
        SOURCE_DIR ${ctps_src}
        CONFIGURE_COMMAND ""
        BUILD_COMMAND ""
        INSTALL_COMMAND ""
        TEST_COMMAND ""
    )

    add_dependencies(CataAnalyzerPlugin clang-tidy-plugin-support)
    target_include_directories(
        CataAnalyzerPlugin SYSTEM PRIVATE ${ctps_src}/include)
else()
    target_include_directories(
        CataAnalyzerPlugin SYSTEM PRIVATE ${CATA_CLANG_TIDY_INCLUDE_DIR})
endif()

target_compile_definitions(
    CataAnalyzerPlugin PRIVATE ${LLVM_DEFINITIONS})

# We need to turn off exceptions and RTTI to match the LLVM build.
# I feel there ought to be a way to extract these flags from the
# LLVMConfig.cmake as we have done for e.g. LLVM_INCLUDE_DIRS above, but I
# haven't found one.
if(MSVC)
else()
    target_compile_options(
        CataAnalyzerPlugin PRIVATE -fno-exceptions -fno-rtti)
endif()

configure_file(test/lit.site.cfg.in test/lit.site.cfg @ONLY)
configure_file(test/.clang-tidy test/.clang-tidy COPYONLY)

=== tools/format/CMakeLists.txt ===
include(ExternalProject)

add_executable(
    json_formatter
    format.cpp
    ${CMAKE_SOURCE_DIR}/src/json.cpp
    )

ADD_DEFINITIONS(-DCATA_IN_TOOL)

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/src )

=== debian/changelog ===
cataclysm-dda (0.E-2) unstable; urgency=medium

  * Delay building of tests to dh_auto_test and skip test runs on mipsel.
    The mipsel buildd was running out of memory while linking the tests.
  * Move more build dependencies to Build-Depends-Arch.
  * Don't run tests if nocheck build option is set.
  * Improve cross buildability:
    - Don't run json linter during build
    - Use PKG_CONFIG variable consistently in Makefile

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 04 Apr 2020 17:41:50 +0200

cataclysm-dda (0.E-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches and drop obsolete ones.
  * Drop dependencies and other references to Lua, as upstream dropped
    support.
  * Update watch file URL to get latest release without pre-releases.
  * Bump Standards-Version to 4.5.0.
  * Build-depend on gettext.
  * Update copyrights.

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 01 Apr 2020 23:10:39 +0200

=== debian/control ===
Source: cataclysm-dda
Maintainer: Reiner Herrmann <reiner@reiner-h.de>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 12),
               gettext
Build-Depends-Arch: libncursesw5-dev,
                    librsvg2-bin,
                    libsdl2-dev,
                    libsdl2-image-dev,
                    libsdl2-mixer-dev,
                    libsdl2-ttf-dev,
                    pkg-config
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://cataclysmdda.org/
Vcs-Git: https://salsa.debian.org/deki-guest/cataclysm-dda.git
Vcs-Browser: https://salsa.debian.org/deki-guest/cataclysm-dda

Package: cataclysm-dda-data
Architecture: all
Multi-Arch: foreign
Depends: ttf-unifont,
         ${misc:Depends}
Description: post-apocalyptic roguelike game - data files
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the data files required by any of the frontends.

Package: cataclysm-dda-curses
Architecture: any
Depends: cataclysm-dda-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: cataclysm-dda
Description: post-apocalyptic roguelike game - curses interface
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the text-only ncurses-based interface.

Package: cataclysm-dda-sdl
Architecture: any
Depends: cataclysm-dda-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Provides: cataclysm-dda
Description: post-apocalyptic roguelike game - SDL interface
 Cataclysm: Dark Days Ahead is a roguelike set in a post-apocalyptic world.
 .
 While some have described it as a "zombie game", there's far more to Cataclysm
 than that. Struggle to survive in a harsh, persistent, procedurally generated
 world. Scavenge the remnants of a dead civilization for food, equipment, or,
 if you're lucky, a vehicle with a full tank of gas to get you the hell out of
 Dodge. Fight to defeat or escape from a wide variety of powerful monstrosities,
 from zombies to giant insects to killer robots and things far stranger and
 deadlier, and against the others like yourself, that want what you have...
 .
 This package contains the graphical SDL2-based interface.

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

SDL_FLAGS = TILES=1 SOUND=1
CURSES_FLAGS =
COMMON_FLAGS = VERSION=$(DEB_VERSION_UPSTREAM) PREFIX=/usr ASTYLE=0 RELEASE=1 USE_XDG_DIR=1 LANGUAGES=all DEBUG_SYMBOLS=1 LINTJSON=0

# for building with ccache
#COMMON_FLAGS += CCACHE=1

%:
	dh $@

override_dh_auto_build-arch:
	dh_auto_build -- RUNTESTS=0 $(COMMON_FLAGS) $(CURSES_FLAGS)
	dh_auto_build -- RUNTESTS=0 $(COMMON_FLAGS) $(SDL_FLAGS)
	# generate icons
	for size in 16 32 64 128; do \
		mkdir -p debian/icons/hicolor/$${size}x$${size}/apps; \
		rsvg-convert -o debian/icons/hicolor/$${size}x$${size}/apps/cataclysm-dda.png -w $${size} data/xdg/cataclysm-dda.svg ; \
	done

override_dh_auto_build-indep:

override_dh_auto_install-arch:
	$(MAKE) install-bin DESTDIR=debian/tmp $(COMMON_FLAGS) $(CURSES_FLAGS)
	$(MAKE) install-bin DESTDIR=debian/tmp $(COMMON_FLAGS) $(SDL_FLAGS)

override_dh_auto_install-indep:
	$(MAKE) install-data DESTDIR=debian/tmp $(COMMON_FLAGS) $(SDL_FLAGS)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
	# mipsel buildd runs out of memory while linking the test binary.
ifneq ($(DEB_HOST_ARCH), mipsel)
	# we need to pass build flags, otherwise some files are regenerated
	# and the binaries are relinked.
	LC_ALL=C.UTF-8 XDG_CONFIG_HOME=. dh_auto_test -- RUNTESTS=1 $(COMMON_FLAGS)
endif
endif

override_dh_auto_test-indep:

override_dh_install:
	dh_install -Xfont/ -Xcataicon.ico -XLICENSE.txt -XLICENSE-OFL-Terminus-Font.txt -Xchangelog.txt

override_dh_clean:
	$(MAKE) clean distclean
	dh_clean

override_dh_installchangelogs:
	dh_installchangelogs data/changelog.txt
